///home/berryj/link/bin/genMethods "-g" "-t" "AttributeBase" "-I" "LINK/graph/Attribute.h" "-d" "graph" "-y" "display_attribute" "-w" "free_attribute" 
#include <stk.h>
#include <LINK/stkWrapper/LINK_STk.h>

#include <LINK/graph/Attribute.h>

#include <LINK/stkWrapper/Wrapper.h>
#include <LINK/stkWrapper/Register.h>

void display_attribute(SCM, SCM, int);
void free_attribute(SCM);

typedef AttributeBase _AttributeBase;

#define _AttributeBaseDATA(x) ((AttributeBase*) (EXTDATA(x)))
#define _AttributeBaseIS_DATA(x) (TYPEP(x, tc_CXXwrapper) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<AttributeBase >::type))
#define _AttributeBaseISNT_DATA(x) (!_AttributeBaseIS_DATA(x))

#define _AttributeBaseCXX_DATA(x) (*(AttributeBase*) (EXTDATA(VAL(x))))
#define _AttributeBaseCXX_IS_DATA(x) (INSTANCEP(x) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<AttributeBase >::type))
#define _AttributeBaseCXX_ISNT_DATA(x) (!_AttributeBaseCXX_IS_DATA(x))


PRIMITIVE STk_init__AttributeBase()
{
	Wrapper<_AttributeBase>::type = STk_new_CXXwrapper_id(
			Wrapper<_AttributeBase>::name, 
			"",
			(void (*)(SCM x, SCM port, int mode))
			display_attribute,
			(void (*)(SCM x))0,
			(void (*)(SCM x))free_attribute);
	Tcl_InitHashTable(&Register<_AttributeBase>::objTable, TCL_ONE_WORD_KEYS);
	return UNDEFINED;
}

void genExtra_AttributeBaseMethods(void);

PRIMITIVE STk_init_methods__AttributeBase()
{
	genExtra_AttributeBaseMethods();
	return UNDEFINED;
}
